Overview
Seam is a simple API to connect and control almost any smartlocks. Seam already integrates popular smartlock brands such as August, Yale, Schlage, Igloo, and Kwikset, as well as lesser known ones like Nuki, Wyze, or TTLock. The main benefit of Seam is that you can connect devices from these brands and control them with an easy to use API without having to worry about the underlying specific of each devices. Seam abstracts functions in capabilities such asaccess_codes or locks which you can use to integrate devices from multiple brands while expecting them to all behave more or less in the same way.
This guide is intended to show you how to connect and control smartlocks. To learn more about all devices supported by Seam such as thermostats and sensors, head over to our integration page.
Let’s get started.
1 — Install Seam SDK
Seam provides client libraries for many languages, such as JavaScript, Python, Ruby, PHP, and others, as well as a Postman collection and OpenAPI spec.- JavaScript / TypeScript (npm, GitHub)
- Python (pip, GitHub)
- Ruby Gem (rubygem, GitHub)
- PHP (packagist, GitHub)
- C# (nuget, GitHub)
- JavaScript
- Python
- Ruby
- PHP
- C#
This guide uses a Sandbox Workspace. Only virtual devices can be connected. If
you need to connect a real device, use a non-sandbox workspace and API key.
2 — Link Your Smartlock Account with Seam
To control a smartlock via the Seam API, we need to first connect to your smartlock account and authorize your Seam workspace to control its device(s). To make this easy, Seam provides Connect Webviews authorization flows that walk you (or a device owner) through authorizing your workspace to control your device.Request a Connect Webview
To start, we will create a Connect Webview and pass “stable” as theprovider_category. This will ensure that only stable integrations are being presented.
Authorize Your Workspace
Using a browser, navigate to the URL returned by the Connect Webview object. If you are in a sandbox workspace, you can select Yale as the provider and use the test login below to complete the process. If you have a non-sandbox workspace and a real device, simply use your account credentials. Yale Test credentials:- email: jane@example.com
- password: 1234
3 — Retrieve Smartlock Devices
After an account is linked with Seam, you can retrieve devices for this linked account. The Seam API exposes most of the device’s properties such as battery level or door lock status.4 — Locking & Unlocking a Door
Next, you can perform the basic action of locking and unlocking the door as most devices will support thelocks capability.
POST undefined/locks/lock_door
Unlock a door
POST
https://connect.getseam.com/locks/unlock_door
Request Body
| Name | Type | Description |
|---|---|---|
| device_id | String |
5 — Setting Access Code
Many smartlocks have a built-in keypad or an external one that can be paired over bluetooth. This lets you program access codes that a user can then enter at a later time to unlock a door. The Seam API makes it easy to program bothongoing codes and timebound codes on a smartlock. An ongoing code is a code that will be permanently programmed onto the device until you tell the Seam API you wish to remove it. A timebound code is, as the time implies, time bound by a set of ISO8601 timestamp that you provide the Seam API. You can find out more about access code in our core concept section on access codes.

